# **Information about Tutorials - Beginners Start Here!**

## Why Tutorials?

These tutorials are provided to assist in your adventures in `Javis.jl`!
Each one was made with care, quality, and a good sense of humor to facilitate a fun and educational experience.
If you want to make a tutorial, we encourage you to read some of these tutorials to get a feel for how they are structured and written.
After that, check out our [contributing guidelines](contributing.md) and open up an issue about what tutorial you want to add!

## List of Available Tutorials 📚 

Here is a current list of our tutorials.
Their level of difficulty starts from a beginner `Javis` user to advanced usages of `Javis`.
Currently, these tutorials are available:

- [**Tutorial 1: Making Your First `Javis` Animation!**](tutorials/tutorial_1.md) - a step by step guide to making your first animation with `Javis`.
- [**Tutorial 2: Using Shorthands in Javis!**](tutorials/tutorial_2.md) - Using shothands in `Javis`.
- [**Tutorial 3: What Are Actions?**](tutorials/tutorial_3.md) - an introduction to the most important part of `Javis` - the `Action` object.
- [**Tutorial 4: Rendering `LaTeX` with `Javis`!**](tutorials/tutorial_4.md) - a simple tutorial on how to render `LaTeX` in `Javis` animations.
- [**Tutorial 5: Do You Know Our Mascot? Learn about Transitions and Actions!**](tutorials/tutorial_5.md) - a fun tutorial to make our mascot and learn about the `Action` and `Transition` type methods.
- [**Tutorial 6: Taming the Elements**](tutorials/tutorial_6.md) - how to use `change` to grow or shrink arbitrary objects and using `Javis` with other Julia packages.
- [**Tutorial 7: Using Animations.jl to Create something with more Pep!**](tutorials/tutorial_7.md) - an advanced tutorial to make your animations more interesting.

If you spot an issue with any of these tutorials, please let us know! Thank you!
